#include <stdio.h>
#include <stdlib.h>
#include "liste.h"

void greska(char *s)
{
	fprintf(stderr, "greska: %s\n", s);
	exit(EXIT_FAILURE);
}

cvor* kreiraj_cvor(int vrednost)
{
	cvor *novi = malloc(sizeof(cvor));
	if(novi == NULL)
		greska("alokacija");
	novi->vrednost = vrednost;
	novi->sledeci = NULL;
	return novi;
}

cvor* dodaj_na_pocetak_liste(cvor *glava, int vrednost)
{
	cvor *novi = kreiraj_cvor(vrednost);
	novi->sledeci = glava;
	return novi;
}

cvor* dodaj_na_kraj_liste(cvor *glava, int x)
{
	if(glava == NULL)
		return kreiraj_cvor(x);
	else
	{
		glava->sledeci = 
			dodaj_na_kraj_liste(glava->sledeci, x);
		return glava;
	}
}

cvor* dodaj_u_sortiranu_listu(cvor *glava, int v)
{
	if(glava == NULL)
		return kreiraj_cvor(v);
	else
	{
		//rastuce 1 -> 2 -> 3...
		if(v < glava->vrednost)
		{
			glava = dodaj_na_pocetak_liste(glava, v);
			return glava;
		}
		else
		{
			glava->sledeci = 
				dodaj_u_sortiranu_listu(glava->sledeci, v);
			return glava;
		}
	}
}

cvor* ucitaj_listu_na_pocetak()
{
	cvor *glava = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		glava = dodaj_na_pocetak_liste(glava, x);
	}
	return glava;
}

cvor* ucitaj_listu_na_kraj()
{
	cvor *glava = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		glava = dodaj_na_kraj_liste(glava, x);
	}
	return glava;
}

cvor* ucitaj_sortirano()
{
	cvor *glava = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		glava = dodaj_u_sortiranu_listu(glava, x);
	}
	return glava;
}

cvor* spoj_sortirano(cvor *g1, cvor *g2)
{
	if(g1 == NULL)
		return g2;
	if(g2 == NULL)
		return g1;
	
	if(g1->vrednost < g2->vrednost)
	{
		g1->sledeci = spoj_sortirano(g1->sledeci, g2);
		return g1;
	}
	else
	{
		g2->sledeci = spoj_sortirano(g1, g2->sledeci);
		return g2;
	}
}

void ispis(cvor *glava)
{
	//1 -> 2 -> 3 -> NULL
	while(glava != NULL)
	{
		printf("%d ", glava->vrednost);
		glava = glava->sledeci;
	}
	printf("\n");
}

cvor* oslobodi(cvor *glava)
{
	
	while(glava != NULL)
	{
		cvor* sledeci = glava->sledeci;
		free(glava);
		glava = sledeci;
	}
	return NULL;
}

int duzina(cvor *glava)
{	
	if(glava == NULL)
		return 0;
	else
	{	
		return 1 + duzina(glava->sledeci);
	}
}

cvor* izbaci_b(cvor *glava, int b)
{
	if(glava == NULL)
		return NULL;
	else
	{
		//2 slucaja
		//1. U glavi se nalazi vrednost koju izbacujemo
		//2. U glavi se ne nalazi vrednost koju izbacujemo
		
		//1. 
		if(glava->vrednost == b)
		{
			//preskacemo glavu
			//1->2->3->1.... 1
			//2->3->...
			cvor *sledeci = glava->sledeci;
			free(glava);
			return izbaci_b(sledeci, b);
		}
		else
		{
			glava->sledeci = 
				izbaci_b(glava->sledeci, b);
			return glava;
		}
	}
}